<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>502.60</title>
</head>

<body>

</body>
<script>
    function foo() {
        if (true) {
            var fruit1 = 'apple';
            const fruit2 = 'banana';
            let fruit3 = "strawberry";
        }
        console.log(fruit1);
        console.log(fruit2);
        console.log(fruit3);
    }

    function foo1() {
        var fruit1 = 'apple';
        const fruit2 = 'banana';
        let fruit3 = "strawberry";
        function foo2() {
            console.log(fruit1);
            console.log(fruit2);
            console.log(fruit3);
        }
        foo2();
    }
    // foo();
    // kết quả foo(): fruit1 gọi ra được vì là function scoped (var) nên sẽ hoạt động trong toàn hàm
    //fruit2 và fruit 3 là block scoped (const và let), nên khi gọi ngoài dấu {} của if sẽ không gọi được và báo lỗi.

    foo1();
    //kết quả foo1(): gọi được tất cả 3 biến  vì hàm foo2() được gọi lại trong hàm foo1(); nên khi gọi hàm foo1 ở bên ngoài thì sẽ gọi được tất cả biến block scoped và function scoped.

</script>

</html>